import * as vscode from "vscode";
import { CancellationToken, CustomDocumentBackupContext, CustomDocumentOpenContext, CustomEditorProvider, Uri, WebviewPanel } from "vscode";
import { KogitoEditorFactory } from "./KogitoEditorFactory";
import { KogitoEditorStore } from "./KogitoEditorStore";
import { KogitoEditableDocument } from "./KogitoEditableDocument";
import { VsCodeI18n } from "./i18n";
import { I18n } from "@kie-tools-core/i18n/dist/core";
import { VsCodeNotificationsApi } from "@kie-tools-core/notifications/dist/vscode";
import { EditorEnvelopeLocator } from "@kie-tools-core/editor/dist/api";
export declare class KogitoCustomEditorWebviewProvider implements CustomEditorProvider<KogitoEditableDocument> {
    private readonly context;
    private readonly viewType;
    private readonly editorStore;
    private readonly editorFactory;
    private readonly vsCodeI18n;
    private readonly vsCodeNotificationsApi;
    private readonly editorEnvelopeLocator;
    private readonly _onDidChangeCustomDocument;
    readonly onDidChangeCustomDocument: vscode.Event<vscode.CustomDocumentEditEvent<KogitoEditableDocument>>;
    constructor(context: vscode.ExtensionContext, viewType: string, editorStore: KogitoEditorStore, editorFactory: KogitoEditorFactory, vsCodeI18n: I18n<VsCodeI18n>, vsCodeNotificationsApi: VsCodeNotificationsApi, editorEnvelopeLocator: EditorEnvelopeLocator);
    register(): vscode.Disposable;
    resolveCustomEditor(document: KogitoEditableDocument, webviewPanel: WebviewPanel, cancellation: CancellationToken): Promise<void>;
    openCustomDocument(uri: Uri, openContext: CustomDocumentOpenContext, cancellation: CancellationToken): Promise<KogitoEditableDocument>;
    saveCustomDocument(document: KogitoEditableDocument, cancellation: CancellationToken): Promise<void>;
    saveCustomDocumentAs(document: KogitoEditableDocument, dest: Uri, cancellation: CancellationToken): Promise<void>;
    revertCustomDocument(document: KogitoEditableDocument, cancellation: CancellationToken): Promise<void>;
    backupCustomDocument(document: KogitoEditableDocument, context: CustomDocumentBackupContext, cancellation: CancellationToken): Promise<vscode.CustomDocumentBackup>;
    private createStorageFolder;
    private setupListeners;
    private resolveBackupUri;
}
//# sourceMappingURL=KogitoCustomEditorWebviewProvider.d.ts.map