import { KogitoEdit } from "@kie-tools-core/workspace/dist/api";
import { I18n } from "@kie-tools-core/i18n/dist/core";
import { VsCodeNotificationsApi } from "@kie-tools-core/notifications/dist/vscode";
import * as vscode from "vscode";
import { CancellationToken, CustomDocument, CustomDocumentBackup, Uri } from "vscode";
import { VsCodeI18n } from "./i18n";
import { KogitoEditor } from "./KogitoEditor";
import { KogitoEditorStore } from "./KogitoEditorStore";
import { EditorEnvelopeLocator } from "@kie-tools-core/editor/dist/api";
export declare class KogitoEditableDocument implements CustomDocument {
    readonly uri: Uri;
    readonly initialBackup: Uri | undefined;
    readonly editorStore: KogitoEditorStore;
    private readonly vsCodeI18n;
    private readonly vsCodeNotifications;
    private readonly editorEnvelopeLocator;
    private readonly encoder;
    private readonly decoder;
    private readonly vsCodeLogger;
    private readonly _onDidDispose;
    readonly onDidDispose: vscode.Event<void>;
    private readonly _onDidChange;
    readonly onDidChange: vscode.Event<vscode.CustomDocumentEditEvent<KogitoEditableDocument>>;
    constructor(uri: Uri, initialBackup: Uri | undefined, editorStore: KogitoEditorStore, vsCodeI18n: I18n<VsCodeI18n>, vsCodeNotifications: VsCodeNotificationsApi, editorEnvelopeLocator: EditorEnvelopeLocator);
    dispose(): void;
    get relativePath(): string;
    get fileExtension(): string;
    get fileType(): string | undefined;
    save(destination: Uri, cancellation: CancellationToken): Promise<void>;
    backup(destination: Uri, cancellation: CancellationToken): Promise<CustomDocumentBackup>;
    revert(cancellation: CancellationToken): Promise<void>;
    notifyEdit(editor: KogitoEditor, edit: KogitoEdit): void;
}
//# sourceMappingURL=KogitoEditableDocument.d.ts.map