import * as vscode from "vscode";
import { TextDocument } from "vscode";
import { EditorApi, EditorEnvelopeLocator, EditorTheme, EnvelopeMapping, KogitoEditorChannelApi, KogitoEditorEnvelopeApi } from "@kie-tools-core/editor/dist/api";
import { KogitoEditorStore } from "./KogitoEditorStore";
import { EnvelopeBusMessageBroadcaster } from "./EnvelopeBusMessageBroadcaster";
import { EnvelopeServer } from "@kie-tools-core/envelope-bus/dist/channel";
import { KogitoEditableDocument } from "./KogitoEditableDocument";
export declare type KogitoEditorDocument = {
    type: "text";
    document: TextDocument;
} | {
    type: "custom";
    document: KogitoEditableDocument;
};
export declare class KogitoEditor implements EditorApi {
    readonly document: KogitoEditorDocument;
    readonly panel: vscode.WebviewPanel;
    private readonly context;
    private readonly editorStore;
    private readonly envelopeMapping;
    private readonly envelopeLocator;
    private readonly messageBroadcaster;
    readonly envelopeServer: EnvelopeServer<KogitoEditorChannelApi, KogitoEditorEnvelopeApi>;
    private broadcastSubscription;
    private changeDocumentSubscription;
    constructor(document: KogitoEditorDocument, panel: vscode.WebviewPanel, context: vscode.ExtensionContext, editorStore: KogitoEditorStore, envelopeMapping: EnvelopeMapping, envelopeLocator: EditorEnvelopeLocator, messageBroadcaster: EnvelopeBusMessageBroadcaster, envelopeServer?: EnvelopeServer<KogitoEditorChannelApi, KogitoEditorEnvelopeApi>);
    private getEditorThemeByVscodeTheme;
    getCurrentTheme(): EditorTheme;
    getElementPosition(selector: string): Promise<import("@kie-tools-core/guided-tour/dist/api").Rect>;
    getContent(): Promise<string>;
    setContent(path: string, content: string): Promise<void>;
    undo(): Promise<void>;
    redo(): Promise<void>;
    getPreview(): Promise<string>;
    validate(): Promise<import("@kie-tools-core/notifications/dist/api").Notification[]>;
    setTheme(theme: EditorTheme): Promise<void>;
    startInitPolling(apiImpl: KogitoEditorChannelApi): void;
    startListening(apiImpl: KogitoEditorChannelApi): void;
    setupPanelActiveStatusChange(): void;
    setupPanelOnDidDispose(): void;
    close(): void;
    hasUri(uri: vscode.Uri): boolean;
    isActive(): boolean;
    setupWebviewContent(): void;
    startListeningToThemeChanges(): void;
    stopListeningToDocumentChanges(): void;
    startListeningToDocumentChanges(): void;
    getDocumentContent(): Promise<string>;
}
//# sourceMappingURL=KogitoEditor.d.ts.map