"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.KogitoEditorStore = void 0;
var KogitoEditorStore = (function () {
    function KogitoEditorStore() {
        this.openEditors = new Set();
    }
    KogitoEditorStore.prototype.addAsActive = function (editor) {
        this.activeEditor = editor;
        this.openEditors.add(editor);
    };
    KogitoEditorStore.prototype.setActive = function (editor) {
        this.activeEditor = editor;
    };
    KogitoEditorStore.prototype.isActive = function (editor) {
        return this.activeEditor === editor;
    };
    KogitoEditorStore.prototype.setNoneActive = function () {
        this.activeEditor = undefined;
    };
    KogitoEditorStore.prototype.close = function (editor) {
        this.openEditors.delete(editor);
        if (this.isActive(editor)) {
            this.setNoneActive();
        }
    };
    KogitoEditorStore.prototype.get = function (uri) {
        var found;
        this.openEditors.forEach(function (editor) {
            if (editor.hasUri(uri)) {
                found = editor;
            }
        });
        return found;
    };
    return KogitoEditorStore;
}());
exports.KogitoEditorStore = KogitoEditorStore;
//# sourceMappingURL=KogitoEditorStore.js.map