"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VsCodeResourceContentService = void 0;
var api_1 = require("@kie-tools-core/workspace/dist/api");
var vscode = require("vscode");
var __path = require("path");
var vscode_1 = require("vscode");
var VsCodeResourceContentService = (function () {
    function VsCodeResourceContentService(currentAssetFolder) {
        this.currentAssetFolder = currentAssetFolder;
    }
    VsCodeResourceContentService.prototype.list = function (pattern, opts) {
        return __awaiter(this, void 0, void 0, function () {
            var workspaceFolderPath, basePath, relativePattern, files, paths;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        workspaceFolderPath = vscode.workspace.workspaceFolders[0].uri.fsPath + __path.sep;
                        basePath = (opts === null || opts === void 0 ? void 0 : opts.type) === api_1.SearchType.ASSET_FOLDER ? workspaceFolderPath + this.currentAssetFolder : workspaceFolderPath;
                        relativePattern = new vscode_1.RelativePattern(basePath, pattern);
                        return [4, vscode.workspace.findFiles(relativePattern)];
                    case 1:
                        files = _a.sent();
                        paths = files.map(function (uri) { return vscode.workspace.asRelativePath(uri); });
                        return [2, new api_1.ResourcesList(pattern, paths)];
                }
            });
        });
    };
    VsCodeResourceContentService.prototype.get = function (path, opts) {
        return __awaiter(this, void 0, void 0, function () {
            var contentPath, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contentPath = this.resolvePath(path);
                        if (!contentPath) {
                            return [2, new api_1.ResourceContent(path, undefined)];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, vscode.workspace.fs.stat(vscode.Uri.parse(contentPath))];
                    case 2:
                        _a.sent();
                        return [3, 4];
                    case 3:
                        e_1 = _a.sent();
                        console.warn("Error checking file ".concat(path, ": ").concat(e_1));
                        return [2, new api_1.ResourceContent(path, undefined)];
                    case 4: return [2, this.retrieveContent(opts === null || opts === void 0 ? void 0 : opts.type, path, contentPath)];
                }
            });
        });
    };
    VsCodeResourceContentService.prototype.resolvePath = function (uri) {
        var folders = vscode.workspace.workspaceFolders;
        if (folders) {
            var rootPath = folders[0].uri.path;
            if (!uri.startsWith(__path.sep)) {
                uri = __path.sep + uri;
            }
            return rootPath + uri;
        }
        return null;
    };
    VsCodeResourceContentService.prototype.retrieveContent = function (type, path, contentPath) {
        if (type === api_1.ContentType.BINARY) {
            return vscode.workspace.fs
                .readFile(vscode.Uri.parse(contentPath))
                .then(function (content) { return new api_1.ResourceContent(path, Buffer.from(content).toString("base64"), api_1.ContentType.BINARY); });
        }
        else {
            return vscode.workspace
                .openTextDocument(contentPath)
                .then(function (textDoc) { return new api_1.ResourceContent(path, textDoc.getText(), api_1.ContentType.TEXT); });
        }
    };
    return VsCodeResourceContentService;
}());
exports.VsCodeResourceContentService = VsCodeResourceContentService;
//# sourceMappingURL=VsCodeResourceContentService.js.map