"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.startExtension = void 0;
var core_1 = require("@kie-tools-core/i18n/dist/core");
var vscode_1 = require("@kie-tools-core/workspace/dist/vscode");
var vscode = require("vscode");
var EnvelopeBusMessageBroadcaster_1 = require("./EnvelopeBusMessageBroadcaster");
var generateSvg_1 = require("./generateSvg");
var i18n_1 = require("./i18n");
var KogitoEditorFactory_1 = require("./KogitoEditorFactory");
var KogitoEditorStore_1 = require("./KogitoEditorStore");
var KogitoTextEditorWebviewProvider_1 = require("./KogitoTextEditorWebviewProvider");
var vscode_2 = require("@kie-tools-core/notifications/dist/vscode");
var vscode_3 = require("@kie-tools-core/vscode-java-code-completion/dist/vscode");
var KogitoCustomEditorWebviewProvider_1 = require("./KogitoCustomEditorWebviewProvider");
var onSaveHook_1 = require("./onSaveHook");
function startExtension(args) {
    return __awaiter(this, void 0, void 0, function () {
        var vsCodeI18n, workspaceApi, editorStore, messageBroadcaster, vsCodeNotificationsApi, vsCodeJavaCodeCompletionChannelApi, editorFactory;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, args.backendProxy.tryLoadBackendExtension(true)];
                case 1:
                    _a.sent();
                    vsCodeI18n = new core_1.I18n(i18n_1.vsCodeI18nDefaults, i18n_1.vsCodeI18nDictionaries, vscode.env.language);
                    workspaceApi = new vscode_1.VsCodeWorkspaceApi();
                    editorStore = new KogitoEditorStore_1.KogitoEditorStore();
                    messageBroadcaster = new EnvelopeBusMessageBroadcaster_1.EnvelopeBusMessageBroadcaster();
                    vsCodeNotificationsApi = new vscode_2.VsCodeNotificationsApi(workspaceApi);
                    vsCodeJavaCodeCompletionChannelApi = new vscode_3.VsCodeJavaCodeCompletionImpl();
                    editorFactory = new KogitoEditorFactory_1.KogitoEditorFactory(args.context, editorStore, args.editorEnvelopeLocator, messageBroadcaster, workspaceApi, args.backendProxy, vsCodeNotificationsApi, vsCodeJavaCodeCompletionChannelApi, args.viewType, vsCodeI18n, args.channelApiProducer);
                    if (args.editorDocumentType === undefined || args.editorDocumentType === "custom") {
                        args.context.subscriptions.push(vscode.window.registerCustomEditorProvider(args.viewType, new KogitoCustomEditorWebviewProvider_1.KogitoCustomEditorWebviewProvider(args.context, args.viewType, editorStore, editorFactory, vsCodeI18n, vsCodeNotificationsApi, args.editorEnvelopeLocator), {
                            webviewOptions: { retainContextWhenHidden: true },
                        }));
                    }
                    else if (args.editorDocumentType === "text") {
                        args.context.subscriptions.push(vscode.window.registerCustomEditorProvider(args.viewType, new KogitoTextEditorWebviewProvider_1.KogitoTextEditorWebviewProvider(args.context, args.viewType, editorFactory), {
                            webviewOptions: { retainContextWhenHidden: true },
                        }));
                        args.context.subscriptions.push(vscode.workspace.onDidSaveTextDocument(function (document) {
                            var envelopeMapping = args.editorEnvelopeLocator.getEnvelopeMapping(document.uri.fsPath);
                            if (envelopeMapping) {
                                (0, onSaveHook_1.executeOnSaveHook)(envelopeMapping.type);
                            }
                        }));
                    }
                    else {
                        throw new Error("Type not supported");
                    }
                    if (args.generateSvgCommandId !== undefined) {
                        args.context.subscriptions.push(vscode.commands.registerCommand(args.generateSvgCommandId, function () {
                            return (0, generateSvg_1.generateSvg)({
                                editorStore: editorStore,
                                workspaceApi: workspaceApi,
                                vsCodeI18n: vsCodeI18n,
                                displayNotification: true,
                                editorEnvelopeLocator: args.editorEnvelopeLocator,
                            });
                        }));
                    }
                    if (args.silentlyGenerateSvgCommandId !== undefined) {
                        args.context.subscriptions.push(vscode.commands.registerCommand(args.silentlyGenerateSvgCommandId, function () {
                            return (0, generateSvg_1.generateSvg)({
                                editorStore: editorStore,
                                workspaceApi: workspaceApi,
                                vsCodeI18n: vsCodeI18n,
                                displayNotification: false,
                                editorEnvelopeLocator: args.editorEnvelopeLocator,
                            });
                        }));
                    }
                    return [2, editorStore];
            }
        });
    });
}
exports.startExtension = startExtension;
__exportStar(require("./KogitoEditorStore"), exports);
//# sourceMappingURL=index.js.map